## rustc 1.19.0+dfsg3-3ubuntu1~16.04.1+8.0trisquel1

=== src/rt/hoedown/Makefile ===
CFLAGS = -g -O3 -ansi -pedantic -Wall -Wextra -Wno-unused-parameter
PREFIX = /usr/local
BINDIR = $(PREFIX)/bin
LIBDIR = $(PREFIX)/lib
INCLUDEDIR = $(PREFIX)/include

HOEDOWN_CFLAGS = $(CFLAGS) -Isrc
ifneq ($(OS),Windows_NT)
	HOEDOWN_CFLAGS += -fPIC
endif

SONAME = -soname
ifeq ($(shell uname -s),Darwin)
	SONAME = -install_name
endif

HOEDOWN_SRC=\
	src/autolink.o \
	src/buffer.o \
	src/document.o \
	src/escape.o \
	src/html.o \
	src/html_blocks.o \
	src/html_smartypants.o \
	src/stack.o \
	src/version.o

.PHONY:		all test test-pl clean

all:		libhoedown.so libhoedown.a hoedown smartypants

# Libraries

libhoedown.so: libhoedown.so.3
	ln -f -s $^ $@

libhoedown.so.3: $(HOEDOWN_SRC)
	$(CC) -Wl,$(SONAME),$(@F) -shared $^ $(LDFLAGS) -o $@

libhoedown.a: $(HOEDOWN_SRC)
	$(AR) rcs libhoedown.a $^

# Executables

hoedown: bin/hoedown.o $(HOEDOWN_SRC)
	$(CC) $^ $(LDFLAGS) -o $@

smartypants: bin/smartypants.o $(HOEDOWN_SRC)
	$(CC) $^ $(LDFLAGS) -o $@

# Perfect hashing

src/html_blocks.c: html_block_names.gperf
	gperf -I -L ANSI-C -N hoedown_find_block_tag -c -C -E -S 1 --ignore-case -m100 $^ > $@

# Testing

test: hoedown libhoedown.a
	$(CC) test/line.c libhoedown.a -o test/tester
	python test/runner.py

test-pl: hoedown
	perl test/MarkdownTest_1.0.3/MarkdownTest.pl \
		--script=./hoedown --testdir=test/MarkdownTest_1.0.3/Tests --tidy

# Housekeeping

clean:
	$(RM) src/*.o bin/*.o
	$(RM) libhoedown.so libhoedown.so.1 libhoedown.a
	$(RM) hoedown smartypants hoedown.exe smartypants.exe

# Installing

install:
	install -m755 -d $(DESTDIR)$(LIBDIR)
	install -m755 -d $(DESTDIR)$(BINDIR)
	install -m755 -d $(DESTDIR)$(INCLUDEDIR)

	install -m644 libhoedown.a $(DESTDIR)$(LIBDIR)
	install -m755 libhoedown.so.3 $(DESTDIR)$(LIBDIR)
	ln -f -s libhoedown.so.3 $(DESTDIR)$(LIBDIR)/libhoedown.so

	install -m755 hoedown $(DESTDIR)$(BINDIR)
	install -m755 smartypants $(DESTDIR)$(BINDIR)

	install -m755 -d $(DESTDIR)$(INCLUDEDIR)/hoedown
	install -m644 src/*.h $(DESTDIR)$(INCLUDEDIR)/hoedown

# Generic object compilations

%.o: %.c
	$(CC) $(HOEDOWN_CFLAGS) -c -o $@ $<

src/html_blocks.o: src/html_blocks.c
	$(CC) $(HOEDOWN_CFLAGS) -Wno-static-in-inline -c -o $@ $<

=== src/test/run-make/atomic-lock-free/Makefile ===
-include ../tools.mk

# This tests ensure that atomic types are never lowered into runtime library calls that are not
# guaranteed to be lock-free.

all:
ifeq ($(UNAME),Linux)
ifeq (,$(filter armv7-unknown-linux-gnueabihf,$(TARGET)))
ifeq ($(filter x86,$(LLVM_COMPONENTS)),x86)
	$(RUSTC) --target=i686-unknown-linux-gnu atomic_lock_free.rs
	nm "$(TMPDIR)/libatomic_lock_free.rlib" | grep -vq __atomic_fetch_add
	$(RUSTC) --target=x86_64-unknown-linux-gnu atomic_lock_free.rs
	nm "$(TMPDIR)/libatomic_lock_free.rlib" | grep -vq __atomic_fetch_add
endif
ifeq ($(filter arm,$(LLVM_COMPONENTS)),arm)
	$(RUSTC) --target=arm-unknown-linux-gnueabi atomic_lock_free.rs
	nm "$(TMPDIR)/libatomic_lock_free.rlib" | grep -vq __atomic_fetch_add
	$(RUSTC) --target=arm-unknown-linux-gnueabihf atomic_lock_free.rs
	nm "$(TMPDIR)/libatomic_lock_free.rlib" | grep -vq __atomic_fetch_add
	$(RUSTC) --target=armv7-unknown-linux-gnueabihf atomic_lock_free.rs
	nm "$(TMPDIR)/libatomic_lock_free.rlib" | grep -vq __atomic_fetch_add
endif
ifeq ($(filter aarch64,$(LLVM_COMPONENTS)),aarch64)
	$(RUSTC) --target=aarch64-unknown-linux-gnu atomic_lock_free.rs
	nm "$(TMPDIR)/libatomic_lock_free.rlib" | grep -vq __atomic_fetch_add
endif
ifeq ($(filter mips,$(LLVM_COMPONENTS)),mips)
	$(RUSTC) --target=mips-unknown-linux-gnu atomic_lock_free.rs
	nm "$(TMPDIR)/libatomic_lock_free.rlib" | grep -vq __atomic_fetch_add
	$(RUSTC) --target=mipsel-unknown-linux-gnu atomic_lock_free.rs
	nm "$(TMPDIR)/libatomic_lock_free.rlib" | grep -vq __atomic_fetch_add
endif
ifeq ($(filter powerpc,$(LLVM_COMPONENTS)),powerpc)
	$(RUSTC) --target=powerpc-unknown-linux-gnu atomic_lock_free.rs
	nm "$(TMPDIR)/libatomic_lock_free.rlib" | grep -vq __atomic_fetch_add
	$(RUSTC) --target=powerpc64-unknown-linux-gnu atomic_lock_free.rs
	nm "$(TMPDIR)/libatomic_lock_free.rlib" | grep -vq __atomic_fetch_add
	$(RUSTC) --target=powerpc64le-unknown-linux-gnu atomic_lock_free.rs
	nm "$(TMPDIR)/libatomic_lock_free.rlib" | grep -vq __atomic_fetch_add
	$(RUSTC) --target=s390x-unknown-linux-gnu atomic_lock_free.rs
	nm "$(TMPDIR)/libatomic_lock_free.rlib" | grep -vq __atomic_fetch_add
endif
endif
endif

=== src/test/run-make/extern-fn-struct-passing-abi/Makefile ===
-include ../tools.mk

all: $(call NATIVE_STATICLIB,test)
ifeq (,$(filter armv7-unknown-linux-gnueabihf,$(TARGET)))
	$(RUSTC) test.rs
	$(call RUN,test) || exit 1
endif

=== src/test/run-make/relocation-model/Makefile ===
-include ../tools.mk

all: others
ifneq ($(filter arm,$(LLVM_COMPONENTS)),arm)
# FIXME(#40145)
	$(RUSTC) -C relocation-model=dynamic-no-pic foo.rs
	$(call RUN,foo)

	$(RUSTC) -C relocation-model=default foo.rs
	$(call RUN,foo)
endif
	$(RUSTC) -C relocation-model=dynamic-no-pic --crate-type=dylib foo.rs --emit=link,obj

ifdef IS_MSVC
# FIXME(#28026)
others:
else ifeq ($(filter arm,$(LLVM_COMPONENTS)),arm)
# FIXME(#40145)
others:
else
others:
	$(RUSTC) -C relocation-model=static foo.rs
	$(call RUN,foo)
endif

=== debian/changelog ===
rustc (1.19.0+dfsg3-3ubuntu1~16.04.1+8.0trisquel1) flidas; urgency=medium

  * Backported from http://ppa.launchpad.net/ubuntu-mozilla-
    security/ppa/ubuntu

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Sun, 19 Nov 2017 16:36:34 +0000

rustc (1.19.0+dfsg3-3ubuntu1~16.04.1) xenial; urgency=medium

  * Backport 1.19.0 to xenial
  * Relax llvm-toolchain-4.0 build dependency
  * Relax the gdb requirement and don't build-conflict on gdb-minimal
  * Relax the dependency on xz-utils by commenting out some unused code
    - add debian/patches/d-relax-xz-utils-dependency.patch
    - update debian/patches/series
    - update debian/rules

 -- Chris Coulson <chris.coulson@canonical.com>  Mon, 23 Oct 2017 19:29:08 +0100

rustc (1.19.0+dfsg3-3ubuntu1) artful; urgency=medium

  * Merge from Debian, remaining changes:
    - Backport patch to fix unaligned access in LTO on armhf
      + add debian/patches/u-fix-unaligned-access-in-lto.patch
      + update debian/patches/series

 -- Chris Coulson <chris.coulson@canonical.com>  Wed, 11 Oct 2017 14:00:38 +0100

rustc (1.19.0+dfsg3-3) unstable; urgency=medium

  * Fix a trailing whitespace for tidy.

 -- Ximin Luo <infinity0@debian.org>  Tue, 19 Sep 2017 16:09:41 +0200

rustc (1.19.0+dfsg3-2) unstable; urgency=medium

  * Upload to unstable.
  * Add a patch to print extra information when tests fail.

 -- Ximin Luo <infinity0@debian.org>  Tue, 19 Sep 2017 12:32:03 +0200

rustc (1.19.0+dfsg3-1) experimental; urgency=medium

  * New upstream release.
  * Upgrade to LLVM 4.0. (Closes: #873421)
  * rust-src: install Debian patches as well

 -- Ximin Luo <infinity0@debian.org>  Fri, 15 Sep 2017 04:02:09 +0200

=== debian/control ===
Source: rustc
Section: devel
Priority: extra
Maintainer: Rust Maintainers <pkg-rust-maintainers@lists.alioth.debian.org>
Uploaders: Jordan Justen <jordan.l.justen@intel.com>,
 Luca Bruno <lucab@debian.org>,
 Sylvestre Ledru <sylvestre@debian.org>,
 Angus Lees <gus@debian.org>,
 Ximin Luo <infinity0@debian.org>
#  annotations are to support cross-compiling, see README.Debian
Build-Depends: debhelper (>= 9),
               dpkg-dev (>= 1.17.14),
               python,
               cargo (>= 0.19.0)      <!pkg.rustc.dlstage0>,
               rustc (>= 1.18.0+dfsg) <!pkg.rustc.dlstage0>,
               rustc (<= 1.19.0++)    <!pkg.rustc.dlstage0>,
               llvm-4.0-dev   (>= 1:4.0.1-0ubuntu0.16.04.3~),
               llvm-4.0-tools (>= 1:4.0.1-0ubuntu0.16.04.3~),
               libllvm4.0            (>= 1:4.0.1-0ubuntu0.16.04.3~),
               autotools-dev,
               cmake (>= 3.0) | cmake3,
               gperf,
# this is sometimes needed by rustc_llvm
               zlib1g-dev,
               zlib1g-dev,
# used by rust-installer
               liblzma-dev,
# test dependencies:
               binutils (>= 2.26) <!nocheck> | binutils-2.26 <!nocheck>,
               nodejs <!nocheck>,
               valgrind <!nocheck>,
               git <!nocheck>,
               procps <!nocheck>,
# below are optional tools even for 'make check'
               antlr4 <!nocheck> | antlr <!nocheck>,
               bison <!nocheck>,
               flex <!nocheck>,
               gdb <!nocheck>,
               default-jdk-headless <!nocheck> | default-jdk <!nocheck>,
Standards-Version: 4.0.0
Homepage: http://www.rust-lang.org/
Vcs-Git: https://anonscm.debian.org/git/pkg-rust/rust.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-rust/rust.git

Package: rustc
Architecture: any
Multi-Arch: allowed
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}, libstd-rust-dev (= ${binary:Version}),
 gcc, libc-dev, binutils (>= 2.26)
Recommends: rust-gdb | rust-lldb
Suggests: rust-doc, rust-src
Description: Rust systems programming language
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.

Package: libstd-rust-1.19
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Rust standard libraries
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains the standard Rust libraries, built as dylibs.

Package: libstd-rust-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libstd-rust-1.19 (= ${binary:Version})
Description: Rust standard libraries - development files
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains development files necessary to use the standard
 Rust libraries.

Package: rust-gdb
Architecture: all
Depends: gdb, ${misc:Depends}
Suggests: gdb-doc
Replaces: rustc (<< 1.1.0+dfsg1-1)
Description: Rust debugger (gdb)
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains pretty printers and a wrapper script for
 invoking gdb on rust binaries.

Package: rust-lldb
Architecture: all
# When updating, also update rust-lldb.links
Depends: lldb-4.0, ${misc:Depends}, python-lldb-4.0
Replaces: rustc (<< 1.1.0+dfsg1-1)
Description: Rust debugger (lldb)
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains pretty printers and a wrapper script for
 invoking lldb on rust binaries.

Package: rust-doc
Section: doc
Architecture: all
Build-Profiles: <!nodoc>
Depends: ${misc:Depends},
 libjs-jquery, libjs-highlight.js, libjs-mathjax,
 fonts-open-sans, fonts-font-awesome
Description: Rust systems programming language - Documentation
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains the Rust tutorial, language reference and
 standard library documentation.

Package: rust-src
Section: devel
Architecture: all
Depends: ${misc:Depends}
Description: Rust systems programming language - source code
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains sources of the Rust compiler and standard
 libraries, useful for IDEs and code analysis tools such as Racer.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/vendor.mk
include /usr/share/dpkg/architecture.mk
SED_VERSION_SHORT := sed -re 's/([^.]+)\.([^.]+)\..*/\1.\2/'
RUST_VERSION := $(shell echo '$(DEB_VERSION_UPSTREAM)' | $(SED_VERSION_SHORT))
RUST_LONG_VERSION := $(shell echo '$(DEB_VERSION_UPSTREAM)' | sed -re 's/([^+]+).*/\1/')
LIBSTD_PKG := libstd-rust-$(RUST_VERSION)
# Sed expression that matches the "rustc" we have in our Build-Depends field
SED_RUSTC_BUILDDEP := sed -ne "/^Build-Depends:/,/^[^[:space:]\#]/{/^ *rustc:native .*,/p}" debian/control

include /usr/share/dpkg/buildflags.mk
# TODO: more correct to use `[build] rustflags = []` list syntax in Cargo.toml
RUSTFLAGS = $(addprefix -C link-args=,$(LDFLAGS))
export CFLAGS CXXFLAGS CPPFLAGS LDFLAGS RUSTFLAGS
# set remap-path-prefix for reproducible builds; TODO: remove "if" after 1.20
ifeq (0,$(shell dpkg --compare-versions "$$(rustc --version --verbose | sed -ne 's/^release: //p')" '>=' 1.19.0; echo $$?))
RUSTFLAGS += -Zremap-path-prefix-from=$(CURDIR) -Zremap-path-prefix-to=/usr/src/rustc-$(RUST_LONG_VERSION)
export RUSTC_BOOTSTRAP = 1
endif

# Defines DEB_*_RUST_TYPE triples
include debian/architecture.mk
export DEB_HOST_RUST_TYPE

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# src/rt/miniz.c (incorrectly) triggers -Wmisleading-indentation with
# gcc-6.  See bug #811573.
CFLAGS += -Wno-misleading-indentation

# Release type (one of beta, stable or nightly)
RELEASE_CHANNEL := stable
# See also ./build-preview-dsc.sh for a script that builds a beta/nightly .dsc
# out of this packaging. Furthermore, if the build breaks after importing a new
# upstream stable release, check the do_temporary_fixup function in that file
# to see if we already know what fix to make.

DEB_DESTDIR := $(CURDIR)/debian/tmp

# These are the normal build flags. Upstream is moving to debian/config.toml
# but at the current version not all of these flags are available in that file.
# Certain flags also need to be kept here *as well as* debian/config.toml.in
# because of https://github.com/rust-lang/rust/issues/43295
DEB_CONFIGURE_FLAGS = --enable-llvm-link-shared --disable-dist-src --prefix=/usr --release-channel=$(RELEASE_CHANNEL) --disable-debuginfo-only-std

# Use system LLVM (comment out to use vendored LLVM)
LLVM_VERSION = 4.0
OLD_LLVM_VERSION = 3.9
DEB_CONFIGURE_FLAGS += --llvm-root=/usr/lib/llvm-$(LLVM_VERSION)
RUSTBUILD = RUST_BACKTRACE=1 ./x.py
RUSTBUILD_FLAGS = --config debian/config.toml -v --on-fail env
# TODO: This should simply be "$(RUSTBUILD) test" but unfortunately this causes
# an insane blow up in the time it takes to run tests. See upstream #37477 for
# details. Upstream worked around it in #38984 but in Debian we can't take
# advantage of that work-around, because we want as much debuginfo as possible
# (so we set debuginfo-lines = true, debuginfo-only-std = false) so we have to
# work around it instead by disabling backtrace when running tests.
RUSTBUILD_TEST = ./x.py test
# To run a specific test, run something like:
#   $ debian/rules override_dh_auto_test-arch \
#     RUSTBUILD_TEST_FLAGS="src/test/run-make --test-args extern-fn-struct"
# See src/bootstrap/README.md for more options.
RUSTBUILD_TEST_FLAGS =

update-version:
	oldver=$(shell $(SED_RUSTC_BUILDDEP) | sed -ne 's/.*(<= \(.*\)).*/\1/gp' | $(SED_VERSION_SHORT)); \
	newver=$(RUST_VERSION); \
	if [ $$oldver != $$newver ]; then debian/update-version.sh $$oldver $$newver; fi

# Below we detect how we're supposed to bootstrap the stage0 compiler. See
# README.Debian for more details of the cases described below.
#
PRECONFIGURE_CHECK = :
HAVE_BINARY_TARBALL := $(shell ls -1 stage0/*/*$(DEB_HOST_RUST_TYPE)* 2>/dev/null | wc -l)
# allow not using the binary tarball although it exists
#ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armhf i386 powerpc ppc64el s390x))
#  HAVE_BINARY_TARBALL := 0
#endif
ifeq (0,$(HAVE_BINARY_TARBALL))
    # Case A (Building from source): the extracted source tree does not include
    # a bootstrapping tarball for the current architecture e.g. because the
    # distro already has a rustc for this arch, or the uploader expects that
    # this requirement be fulfilled in some other way.
    #
    # Case A-1: the builder did not select the "pkg.rustc.dlstage0" build profile.
    # In this case, we use the distro's rustc - either the previous or current version.
    ifeq (,$(findstring pkg.rustc.dlstage0,$(DEB_BUILD_PROFILES)))
        DEB_CONFIGURE_FLAGS += --enable-local-rust --local-rust-root=/usr
    endif
    #
    # Case A-2: the builder selected the "dlstage0" build profile.
    # In this case, the rust build scripts will download a stage0 into stage0/ and use that.
    # We don't need to do anything specific in this build file, so this case is empty.
else
    # Case B (Bootstrapping a new distro): the extracted source tree does
    # include a bootstrapping tarball for the current architecture; see the
    # `source_orig-stage0` target below on how to build this.
    #
    # In this case, we'll bootstrap from the stage0 given in that tarball.
    # To ensure the uploader of the .dsc didn't make a mistake, we first check
    # that rustc isn't a Build-Depends for the current architecture.
    ifneq (,$(shell $(SED_RUSTC_BUILDDEP)))
    ifeq (,$(shell $(SED_RUSTC_BUILDDEP) | grep '!$(DEB_HOST_ARCH)'))
        PRECONFIGURE_CHECK = $(error found matches for stage0/*/*$(DEB_HOST_RUST_TYPE)*, \
          but rustc might be a Build-Depends for $(DEB_HOST_ARCH))
    endif
    endif
endif

BUILD_DOCS = 1
ifneq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
  DEB_CONFIGURE_FLAGS += --disable-docs
  BUILD_DOCS =
endif

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
  DEB_CONFIGURE_FLAGS += --disable-optimize --disable-optimize-cxx --disable-optimize-llvm
endif

# Build products or non-source files in src/, that shouldn't go in rust-src
SRC_CLEAN = src/rt/hoedown/src/html_blocks.c \
	src/bootstrap/bootstrap.pyc \
	src/etc/__pycache__/

# Workaround for linux #865549
ifeq (0,$(shell test $$(uname -s) = "Linux" -a $$(getconf PAGESIZE) -gt 4096; echo $$?))
  SYSTEM_WORKAROUNDS += ulimit -s $$(expr $$(getconf PAGESIZE) / 1024 '*' 256 + 8192);
endif

%:
	$(SYSTEM_WORKAROUNDS) dh $@ --parallel

.PHONY: build
build:
	$(SYSTEM_WORKAROUNDS) dh $@ --parallel

override_dh_clean:
	dh_clean -Xsrc/vendor/bitflags/Cargo.toml.orig

debian/configure-upstream: debian/config.toml debian/rules
	rm -f "$@"
	echo '#!/bin/sh' >> "$@"
	echo '# This script can be used to configure a mostly-clean upstream checkout' >> "$@"
	echo '# in case you need to test any differences between it and Debian' >> "$@"
	echo 'set -e' >> "$@"
	echo 'test -f ./configure' >> "$@"
	echo 'cat > config.toml <<EOF' >> "$@"
	cat debian/config.toml >> "$@"
	echo 'EOF' >> "$@"
	echo "./configure $(DEB_CONFIGURE_FLAGS)" >> "$@"
	chmod +x "$@"

debian/config.toml: debian/config.toml.in
	m4  -DDEB_BUILD_RUST_TYPE="$(DEB_BUILD_RUST_TYPE)" \
		-DDEB_HOST_RUST_TYPE="$(DEB_HOST_RUST_TYPE)" \
		-DDEB_TARGET_RUST_TYPE="$(DEB_TARGET_RUST_TYPE)" \
		-DRELEASE_CHANNEL="$(RELEASE_CHANNEL)" \
		-DLLVM_VERSION="$(LLVM_VERSION)" \
		"$<" > "$@"

debian/rust-src.%: debian/rust-src.%.in
	m4  -DRUST_LONG_VERSION="$(RUST_LONG_VERSION)" \
		"$<" > "$@"

override_dh_auto_configure: debian/config.toml
	# fail the build if we have any instances of OLD_LLVM_VERSION in debian, except for debian/changelog
	! grep --color=always -i 'll...\?$(subst .,\.,$(OLD_LLVM_VERSION))' --exclude=changelog -R debian
	$(PRECONFIGURE_CHECK)
	if [ -d stage0 ]; then mkdir -p build && ln -sfT ../stage0 build/cache; fi
	# work around #842634
	if test $$(grep "127.0.0.1\s*localhost" /etc/hosts | wc -l) -gt 1; then \
	  debian/ensure-patch -N debian/patches/d-host-duplicates.patch; fi
	# We patched mdbook and xz2 so have to rm the checksums
	debian/empty-cargo-checksum.py src/vendor/mdbook/.cargo-checksum.json

=== debian/watch ===
version=4
# if you need to download other versions replace the URL below with this one:
# https://static.rust-lang.org/dist/index.html
# it's a bit slower to download, that's why we use the other one normally

opts="\
pgpsigurlmangle=s/$/.asc/,\
uversionmangle=s/(\d)[_.+-]?((beta|alpha)\.?\d*)$/$1~$2/,\
dversionmangle=s/\+dfsg\d*$//,\
repack,\
repacksuffix=+dfsg1,\
compression=xz,\
" \
 https://www.rust-lang.org/en-US/other-installers.html \
 (?:.*/)rustc?-(\d[\d.]*(?:-[\w.]+)?)-src\.tar\.gz

## rustc 1.22.1+dfsg1+llvm

=== debian/changelog ===
rustc (1.22.1+dfsg1+llvm-0ubuntu2~14.04.2) trusty; urgency=medium

  * Backport 1.22.1 to trusty
  * Build-depend on rustc <= 1.22.1++
  * Relax the gdb requirement and don't build-conflict on gdb-minimal
    - update debian/control
  * Relax the dependency on xz-utils by commenting out some unused code
    - add debian/patches/d-relax-xz-utils-dependency.patch
    - update debian/patches/series
    - update debian/rules
  * Relax dpkg-dev requirement to 1.17.5
   - update debian/control
  * Relax binutils requirement. Even though previous uploads have depended
    on a binutils-2.26, we've never actually used it
    - update debian/rules

 -- Chris Coulson <chris.coulson@canonical.com>  Tue, 05 Dec 2017 23:36:38 +0000

rustc (1.22.1+dfsg1+llvm-0ubuntu2) bionic; urgency=medium

  * Merge from Debian experimental, remaining changes:
    - Use the bundled llvm to avoid having to do llvm updates in order to
      deliver rust updates
      - update debian/config.toml.in
      - update debian/control
      - update debian/copyright
      - update debian/rules
    - Fix some test failures that occur because we build rust without an rpath
      - add debian/patches/make-tests-work-without-rpath.patch
      - update debian/patches/series
    - Don't run dynamic_lib::tests::test_loading_cosine on Aarch64 whilst if
      fails there
      - add debian/patches/u-ignoretest-arm64_02.patch
      - update debian/patches/series
    - Make test failures fatal, except on ppc64el and s390x, as there's nothing
      in the archive yet that requires a working rust on these architectures
      - update debian/rules
    - Disable debuginfo when building on 32-bit architectures, as it seems to
      be the only way we can get a successful build
      - update debian/config.toml.in
      - update debian/rules

 -- Chris Coulson <chris.coulson@canonical.com>  Wed, 29 Nov 2017 16:32:51 +0000

rustc (1.22.1+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Fix symlink target. (Closes: #877276)

 -- Ximin Luo <infinity0@debian.org>  Sat, 25 Nov 2017 22:29:12 +0100

rustc (1.21.0+dfsg1-3) unstable; urgency=medium

  * Add/fix detection for sparc64, thanks to John Paul Adrian Glaubitz.
  * Workaround FTBFS when building docs. (Closes: #880262)

 -- Ximin Luo <infinity0@debian.org>  Mon, 06 Nov 2017 10:03:32 +0100

rustc (1.21.0+dfsg1+llvm-0ubuntu5) bionic; urgency=medium

  * Merge from Debian unstable, remaining changes:
    - Don't run dynamic_lib::tests::test_loading_cosine on Aarch64 whilst if
      fails there
      - add debian/patches/u-ignoretest-arm64_02.patch
      - update debian/patches/series
    - Make test failures fatal, except on ppc64el and s390x, as there's nothing
      in the archive yet that requires a working rust on these architectures
      - update debian/rules
    - Use the bundled llvm, as target_feature depends on a rust-specific llvm
      API. This also means we have a different tarball to reinclude the llvm
      parts, although we could probably do this with a supplementary tarball
      in future
      - update debian/control
      - update debian/rules
      - update debian/config.toml.in
    - Fix some test failures that occur because we build rust without an rpath
      - add debian/patches/make-tests-work-without-rpath.patch
      - update debian/patches/series
    - Set build.full-bootstrap to true to work-around a runtime link failure
      when we're bootstrapping from the same rust version
      - update debian/config.toml.in

 -- Chris Coulson <chris.coulson@canonical.com>  Thu, 26 Oct 2017 18:00:24 +0100

rustc (1.21.0+dfsg1-2) unstable; urgency=medium

  * Upload to unstable.
  * Fix bootstrapping using 1.21.0, which is more strict about redundant &mut
    previously used in u-output-failed-commands.patch.
  * Only allow up to 5 test failures.

 -- Ximin Luo <infinity0@debian.org>  Wed, 25 Oct 2017 20:27:30 +0200

rustc (1.21.0+dfsg1-1) experimental; urgency=medium

  * New upstream release.
  * Fix the "install" target for cross-compilations; cross-compiling with
    sbuild --host=$foreign-arch should work again.
  * Update to latest Standards-Version; changes:
    - Priority changed to optional from extra.

 -- Ximin Luo <infinity0@debian.org>  Tue, 17 Oct 2017 00:42:54 +0200

rustc (1.20.0+dfsg1-3) unstable; urgency=medium

  * Disable jemalloc to fix FTBFS with 1.21 on armhf.

 -- Ximin Luo <infinity0@debian.org>  Wed, 25 Oct 2017 12:01:19 +0200

rustc (1.20.0+dfsg1-2) unstable; urgency=medium

  * Update changelog entry for 1.20.0+dfsg1-1 to reflect that it was actually
    and accidentally uploaded to unstable. No harm, no foul.
  * We are no longer failing the build when tests fail, see NEWS or
    README.Debian for details.
  * Bump LLVM requirement to fix some failing tests.

 -- Ximin Luo <infinity0@debian.org>  Sat, 21 Oct 2017 14:20:17 +0200

rustc (1.20.0+dfsg1-1) unstable; urgency=medium

  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Sun, 15 Oct 2017 23:30:35 +0200

rustc (1.19.0+dfsg3-4) unstable; urgency=medium

  * Bump LLVM requirement to pull in a fix for a FTBFS on ppc64el.

 -- Ximin Luo <infinity0@debian.org>  Sun, 15 Oct 2017 21:31:03 +0200

rustc (1.20.0+dfsg0-0ubuntu1) artful; urgency=medium

  * Update to 1.20.0
    - update debian/control
    - libstd-rust-1.19.lintian-overrides
      => libstd-rust-1.20.lintian-overrides

  * update debian/copyright
  * Drop patches that are fixed upstream
    - remove debian/patches/u-only-run-linkchecker-if-docs.patch
    - remove debian/patches/u-skip-main-thread-stack-guard.patch
    - remove debian/patches/u-fix-backtrace-build.patch
    - remove debian/patches/u-ignoretest-arm64_02.patch
    - update debian/patches/series
  * Refresh patches
    - update debian/patches/u-ignoretest-ppc64el_03.patch
    - update debian/patches/u-output-failed-commands.patch
    - update debian/patches/u-allow-stable-features.patch


=== debian/control ===
--- 
+++ 
@@ -1,43 +1,36 @@
 Source: rustc
 Section: devel
-Priority: extra
+Priority: optional
 Maintainer: Rust Maintainers <pkg-rust-maintainers@lists.alioth.debian.org>
 Uploaders: Jordan Justen <jordan.l.justen@intel.com>,
  Luca Bruno <lucab@debian.org>,
  Sylvestre Ledru <sylvestre@debian.org>,
  Angus Lees <gus@debian.org>,
  Ximin Luo <infinity0@debian.org>
-#  annotations are to support cross-compiling, see README.Debian
+# :native annotations are to support cross-compiling, see README.Debian
 Build-Depends: debhelper (>= 9),
-               dpkg-dev (>= 1.17.14),
-               python,
-               cargo (>= 0.19.0)      <!pkg.rustc.dlstage0>,
-               rustc (>= 1.18.0+dfsg) <!pkg.rustc.dlstage0>,
-               rustc (<= 1.19.0++)    <!pkg.rustc.dlstage0>,
-               llvm-4.0-dev   (>= 1:4.0.1-0ubuntu0.16.04.3~),
-               llvm-4.0-tools (>= 1:4.0.1-0ubuntu0.16.04.3~),
-               libllvm4.0            (>= 1:4.0.1-0ubuntu0.16.04.3~),
+               dpkg-dev (>= 1.17.5),
+               python:native,
+               cargo:native (>= 0.19.0)      <!pkg.rustc.dlstage0>,
+               rustc:native (>= 1.21.0+dfsg) <!pkg.rustc.dlstage0>,
+               rustc:native (<= 1.22.1++)    <!pkg.rustc.dlstage0>,
                autotools-dev,
                cmake (>= 3.0) | cmake3,
                gperf,
 # this is sometimes needed by rustc_llvm
-               zlib1g-dev,
+               zlib1g-dev:native,
                zlib1g-dev,
 # used by rust-installer
-               liblzma-dev,
+               liblzma-dev:native,
+# Required for llvm build
+               m4,
 # test dependencies:
-               binutils (>= 2.26) <!nocheck> | binutils-2.26 <!nocheck>,
-               nodejs <!nocheck>,
-               valgrind <!nocheck>,
+               binutils <!nocheck>,
                git <!nocheck>,
                procps <!nocheck>,
 # below are optional tools even for 'make check'
-               antlr4 <!nocheck> | antlr <!nocheck>,
-               bison <!nocheck>,
-               flex <!nocheck>,
                gdb <!nocheck>,
-               default-jdk-headless <!nocheck> | default-jdk <!nocheck>,
-Standards-Version: 4.0.0
+Standards-Version: 4.1.1
 Homepage: http://www.rust-lang.org/
 Vcs-Git: https://anonscm.debian.org/git/pkg-rust/rust.git
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-rust/rust.git
@@ -47,7 +40,7 @@
 Multi-Arch: allowed
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}, libstd-rust-dev (= ${binary:Version}),
- gcc, libc-dev, binutils (>= 2.26)
+ gcc, libc-dev, binutils
 Recommends: rust-gdb | rust-lldb
 Suggests: rust-doc, rust-src
 Description: Rust systems programming language
@@ -63,7 +56,7 @@
  generic programming and meta-programming, in both static and dynamic
  styles.
 
-Package: libstd-rust-1.19
+Package: libstd-rust-1.22
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -88,7 +81,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, libstd-rust-1.19 (= ${binary:Version})
+Depends: ${misc:Depends}, libstd-rust-1.22 (= ${binary:Version})
 Description: Rust standard libraries - development files
  Rust is a curly-brace, block-structured expression language.  It
  visually resembles the C language family, but differs significantly
@@ -171,7 +164,6 @@
  standard library documentation.
 
 Package: rust-src
-Section: devel
 Architecture: all
 Depends: ${misc:Depends}
 Description: Rust systems programming language - source code

=== debian/rules ===
--- 
+++ 
@@ -41,16 +41,6 @@
 
 DEB_DESTDIR := $(CURDIR)/debian/tmp
 
-# These are the normal build flags. Upstream is moving to debian/config.toml
-# but at the current version not all of these flags are available in that file.
-# Certain flags also need to be kept here *as well as* debian/config.toml.in
-# because of https://github.com/rust-lang/rust/issues/43295
-DEB_CONFIGURE_FLAGS = --enable-llvm-link-shared --disable-dist-src --prefix=/usr --release-channel=$(RELEASE_CHANNEL) --disable-debuginfo-only-std
-
-# Use system LLVM (comment out to use vendored LLVM)
-LLVM_VERSION = 4.0
-OLD_LLVM_VERSION = 3.9
-DEB_CONFIGURE_FLAGS += --llvm-root=/usr/lib/llvm-$(LLVM_VERSION)
 RUSTBUILD = RUST_BACKTRACE=1 ./x.py
 RUSTBUILD_FLAGS = --config debian/config.toml -v --on-fail env
 # TODO: This should simply be "$(RUSTBUILD) test" but unfortunately this causes
@@ -76,6 +66,7 @@
 #
 PRECONFIGURE_CHECK = :
 HAVE_BINARY_TARBALL := $(shell ls -1 stage0/*/*$(DEB_HOST_RUST_TYPE)* 2>/dev/null | wc -l)
+DOWNLOAD_BOOTSTRAP := false
 # allow not using the binary tarball although it exists
 #ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armhf i386 powerpc ppc64el s390x))
 #  HAVE_BINARY_TARBALL := 0
@@ -89,12 +80,19 @@
     # Case A-1: the builder did not select the "pkg.rustc.dlstage0" build profile.
     # In this case, we use the distro's rustc - either the previous or current version.
     ifeq (,$(findstring pkg.rustc.dlstage0,$(DEB_BUILD_PROFILES)))
-        DEB_CONFIGURE_FLAGS += --enable-local-rust --local-rust-root=/usr
-    endif
+        # Make it easier to test against a custom rustc
+        ifneq (,$(RUST_DESTDIR))
+        RUST_LIBRARY_PATH := $(RUST_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH):$(RUST_DESTDIR)/usr/lib
+        LD_LIBRARY_PATH := $(if $(LD_LIBRARY_PATH),$(LD_LIBRARY_PATH):$(RUST_LIBRARY_PATH),$(RUST_LIBRARY_PATH))
+        export LD_LIBRARY_PATH
+        endif
     #
     # Case A-2: the builder selected the "dlstage0" build profile.
     # In this case, the rust build scripts will download a stage0 into stage0/ and use that.
     # We don't need to do anything specific in this build file, so this case is empty.
+    else
+        DOWNLOAD_BOOTSTRAP := true
+    endif
 else
     # Case B (Bootstrapping a new distro): the extracted source tree does
     # include a bootstrapping tarball for the current architecture; see the
@@ -111,14 +109,21 @@
     endif
 endif
 
-BUILD_DOCS = 1
+BUILD_DOCS := true
 ifneq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
-  DEB_CONFIGURE_FLAGS += --disable-docs
-  BUILD_DOCS =
+  BUILD_DOCS := false
 endif
 
+MAKE_OPTIMISATIONS := true
 ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
-  DEB_CONFIGURE_FLAGS += --disable-optimize --disable-optimize-cxx --disable-optimize-llvm
+  MAKE_OPTIMISATIONS := false
+endif
+
+BUILD_DEBUGINFO := true
+ifeq (32,$(DEB_BUILD_ARCH_BITS))
+# Building with no debuginfo seems to be the only way to get a
+# successful build on 32-bit build machines
+  BUILD_DEBUGINFO := false
 endif
 
 # Build products or non-source files in src/, that shouldn't go in rust-src
@@ -139,40 +144,39 @@
 	$(SYSTEM_WORKAROUNDS) dh $@ --parallel
 
 override_dh_clean:
-	dh_clean -Xsrc/vendor/bitflags/Cargo.toml.orig
-
-debian/configure-upstream: debian/config.toml debian/rules
-	rm -f "$@"
-	echo '#!/bin/sh' >> "$@"
-	echo '# This script can be used to configure a mostly-clean upstream checkout' >> "$@"
-	echo '# in case you need to test any differences between it and Debian' >> "$@"
-	echo 'set -e' >> "$@"
-	echo 'test -f ./configure' >> "$@"
-	echo 'cat > config.toml <<EOF' >> "$@"
-	cat debian/config.toml >> "$@"
-	echo 'EOF' >> "$@"
-	echo "./configure $(DEB_CONFIGURE_FLAGS)" >> "$@"
-	chmod +x "$@"
+	# Upstream contains a lot of these
+	dh_clean -XCargo.toml.orig
 
 debian/config.toml: debian/config.toml.in
 	m4  -DDEB_BUILD_RUST_TYPE="$(DEB_BUILD_RUST_TYPE)" \
 		-DDEB_HOST_RUST_TYPE="$(DEB_HOST_RUST_TYPE)" \
 		-DDEB_TARGET_RUST_TYPE="$(DEB_TARGET_RUST_TYPE)" \
 		-DRELEASE_CHANNEL="$(RELEASE_CHANNEL)" \
-		-DLLVM_VERSION="$(LLVM_VERSION)" \
+		-DBUILD_DOCS="$(BUILD_DOCS)" \
+		-DMAKE_OPTIMISATIONS="$(MAKE_OPTIMISATIONS)" \
+		-DRUST_DESTDIR="$(RUST_DESTDIR)" \
+		-DBUILD_DEBUGINFO="$(BUILD_DEBUGINFO)" \
 		"$<" > "$@"
+	! $(DOWNLOAD_BOOTSTRAP) || sed -i -e '/^rustc = /d' -e '/^cargo = /d' "$@"
 
 debian/rust-src.%: debian/rust-src.%.in
 	m4  -DRUST_LONG_VERSION="$(RUST_LONG_VERSION)" \
 		"$<" > "$@"
 
 override_dh_auto_configure: debian/config.toml
-	# fail the build if we have any instances of OLD_LLVM_VERSION in debian, except for debian/changelog
-	! grep --color=always -i 'll...\?$(subst .,\.,$(OLD_LLVM_VERSION))' --exclude=changelog -R debian
 	$(PRECONFIGURE_CHECK)
 	if [ -d stage0 ]; then mkdir -p build && ln -sfT ../stage0 build/cache; fi
 	# work around #842634
 	if test $$(grep "127.0.0.1\s*localhost" /etc/hosts | wc -l) -gt 1; then \
 	  debian/ensure-patch -N debian/patches/d-host-duplicates.patch; fi
 	# We patched mdbook and xz2 so have to rm the checksums
-	debian/empty-cargo-checksum.py src/vendor/mdbook/.cargo-checksum.json
+	debian/prune-checksums src/vendor/mdbook/.cargo-checksum.json
+	debian/prune-checksums src/vendor/xz2/.cargo-checksum.json
+	# Unfortunately upstream uses a duplicate copy of libbacktrace and wants to
+	# compile it again for rust-installer, see #43449
+	ln -rsf src/libbacktrace -t src/vendor/backtrace-sys/src/
+	debian/prune-checksums src/vendor/backtrace-sys/.cargo-checksum.json
+	# Link against system liblzma, see https://github.com/alexcrichton/xz2-rs/issues/16
+	echo 'fn main() { println!("cargo:rustc-link-lib=lzma"); }' > src/vendor/lzma-sys/build.rs
+	debian/prune-checksums src/vendor/lzma-sys/.cargo-checksum.json
+	# We excluded some embedded libraries in d/copyright
